var tables = {
	cells: [],
	title: "",
	columns: 0,
	rows: 0,
	id: "",
	setTitle: function(str){
		this.title = str;
	},
	setColumnCount: function(i){
		this.columns = i;
	},
	setHeaderTitles: function(titles){
		if(titles.length != this.columns)
			return console.log("Cannot add row, columns count doesn't match.");
		this.cells[0] = [];
		for(var i=0; i<titles.length; i++)
			this.cells[0][i] = titles[i];
	},
	setRowCount: function(i){
		this.rows = i;
	},
	
	addRow: function(){
		if(arguments.length != this.columns)
			return console.log("Cannot add row, columns count doesn't match.");
		var row = this.cells.length;
		if(row < 1)
			row++;
		this.cells[row] = [];
		for(var i=0; i<arguments.length; i++)
			this.cells[row][i] = arguments[i];
	},
	addRowFromString: function(str){
		var cols = str.split(";");
		if(cols.length != this.columns)
			return console.log("Cannot add row, columns count doesn't match.");
		var row = this.cells.length;
		if(row < 1)
			row++;
			this.cells[row] = [];
		for(var i=0; i<cols.length; i++)
			this.cells[row][i] = cols[i];
	},
	addRowsJson: function(rows){
		for(var i=0; i<rows.length; i++){
			if(rows[i].length != this.columns)
				return console.log("Cannot add row, columns count doesn't match.");
		}
		var row = this.cells.length;
		if(row < 1)
			row++;
		for(var i=0; i<rows.length; i++){
			this.cells[row+i] = [];
			for(var j=0; j<rows[i].length; j++)
				this.cells[row+i][j] = rows[i][j];
		}
	},
	createTable: function(id){
		this.id = id;
		var element = document.getElementById(id);
		if(!element)
			return console.log("Element with id '"+id+"' doesn't exist.");
		element.innerHTML = "";
		if(this.title)
			element.innerHTML += "<div style='text-align: center'>"+this.title+"</div>";
		var str = "<table>";
		if(this.cells[0].length != 0){
			str += "<tr>";
			for(var i=0; i<this.cells[0].length; i++)
				str += "<th class='c"+i+"'>"+this.cells[0][i]+"</th>";
			str += "</tr>";
		}
		this.cells.splice(this.rows+1, this.cells.length-this.rows+1);
		for(var i=1; i<this.cells.length; i++){
			str += "<tr>";
			for(var j=0; j<this.cells[i].length; j++)
				str += "<td class='c"+j+"'>"+this.cells[i][j]+"</td>";
			str += "</tr>";
		}
		element.innerHTML += str;
		
		var ths = element.querySelectorAll("th");
		for(var i=0; i<ths.length; i++){
			ths[i].onmouseover = function(){
				var col = document.getElementsByClassName(this.className);
				for(var i=0; i<col.length; i++)
					col[i].style.backgroundColor = "#BDDEFF";
			}
			ths[i].onmouseout = function(){
				var col = document.getElementsByClassName(this.className);
				for(var i=0; i<col.length; i++)
					col[i].style.backgroundColor = "";
			}
			ths[i].onclick = function(){
				var c = Number(this.className.replace("c",""));
				var sorted = false;
				while(!sorted){
					sorted = true;
					for(var i=1; i<tables.cells.length-2; i++)
						if( (this.getAttribute("data")=="asc" && tables.cells[i][c] < tables.cells[i+1][c]) ||
						(this.getAttribute("data")!="asc" && tables.cells[i][c] > tables.cells[i+1][c] ) ){
							var temp = tables.cells[i][c];
							tables.cells[i][c] = tables.cells[i+1][c];
							tables.cells[i+1][c] = temp;
							sorted = false;
						}
				}
				var condition = this.getAttribute("data")=="asc";
				tables.createTable(tables.id);
				if(condition)
					document.querySelector("th.c"+c).setAttribute("data","desc");
				else
					document.querySelector("th.c"+c).setAttribute("data","asc");
			}
		}
	}
};